#ifndef ED_ARRAY_INCLUDED
#define ED_ARRAY_INCLUDED
#include <stdlib.h>
#include <assert.h>

#define array(T) struct T ## Array
#define arrayTemplate(T) array(T) {\
    size_t size, capacity;\
    T *data;\
};\
array(T) T ## ArrayConstruct(size_t size) {\
    array(T) this;\
    this.size = 0;\
    this.capacity = size;\
    this.data = malloc(size * sizeof(T));\
    if (!this.data) {\
        assert("failed to allocate memory for array");\
    }\
    return this;\
};\
void T ## PushArray(array(T) *arr, T value) {\
    if (arr->size+1 <= arr->capacity) {\
        arr->data[arr->size] = value;\
        arr->size += 1;\
    } else {\
        fprintf(stderr, "failed to push to u8 array, size+num > capacity\n");\
    }\
};

#define newArray(T, size) T ## ArrayConstruct(size)
#define pushArray(T, arr, value) T ## PushArray(arr, (value))

#endif
